package b4a.serviceexample;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.objects.ServiceHelper;
import anywheresoftware.b4a.debug.*;

public class testservice extends android.app.Service {
	public static class testservice_BR extends android.content.BroadcastReceiver {

		@Override
		public void onReceive(android.content.Context context, android.content.Intent intent) {
			android.content.Intent in = new android.content.Intent(context, testservice.class);
			if (intent != null)
				in.putExtra("b4a_internal_intent", intent);
			context.startService(in);
		}

	}
    static testservice mostCurrent;
	public static BA processBA;
    private ServiceHelper _service;
    public static Class<?> getObject() {
		return testservice.class;
	}
	@Override
	public void onCreate() {
        mostCurrent = this;
        if (processBA == null) {
		    processBA = new BA(this, null, null, "b4a.serviceexample", "b4a.serviceexample.testservice");
            try {
                Class.forName(BA.applicationContext.getPackageName() + ".main").getMethod("initializeProcessGlobals").invoke(null, null);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
            processBA.loadHtSubs(this.getClass());
            ServiceHelper.init();
        }
        _service = new ServiceHelper(this);
        processBA.service = this;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Service (testservice) Create **");
        processBA.raiseEvent(null, "service_create");
    }
		@Override
	public void onStart(android.content.Intent intent, int startId) {
		handleStart(intent);
    }
    @Override
    public int onStartCommand(android.content.Intent intent, int flags, int startId) {
    	handleStart(intent);
		return android.app.Service.START_STICKY;
    }
    private void handleStart(android.content.Intent intent) {
    	BA.LogInfo("** Service (testservice) Start **");
    	java.lang.reflect.Method startEvent = processBA.htSubs.get("service_start");
    	if (startEvent != null) {
    		if (startEvent.getParameterTypes().length > 0) {
    			anywheresoftware.b4a.objects.IntentWrapper iw = new anywheresoftware.b4a.objects.IntentWrapper();
    			if (intent != null) {
    				if (intent.hasExtra("b4a_internal_intent"))
    					iw.setObject((android.content.Intent) intent.getParcelableExtra("b4a_internal_intent"));
    				else
    					iw.setObject(intent);
    			}
    			processBA.raiseEvent(null, "service_start", iw);
    		}
    		else {
    			processBA.raiseEvent(null, "service_start");
    		}
    	}
    }
	@Override
	public android.os.IBinder onBind(android.content.Intent intent) {
		return null;
	}
	@Override
	public void onDestroy() {
        BA.LogInfo("** Service (testservice) Destroy **");
		processBA.raiseEvent(null, "service_destroy");
        processBA.service = null;
		mostCurrent = null;
		processBA.setActivityPaused(true);
	}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Timer _timerservice = null;
public static double _mymillisec = 0;
public static double _mysec = 0;
public static double _mymin = 0;
public static double _myhour = 0;
public static double _myday = 0;
public static anywheresoftware.b4a.objects.NotificationWrapper _noti1 = null;
public static long _mynow2 = 0L;
public static long _mytimedelta = 0L;
public b4a.example.dateutils _dateutils = null;
public b4a.serviceexample.main _main = null;
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 6;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 10;BA.debugLine="Dim TimerService As Timer";
_timerservice = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 12;BA.debugLine="Dim MyMilliSec As Double";
_mymillisec = 0;
 //BA.debugLineNum = 13;BA.debugLine="Dim MySec As Double";
_mysec = 0;
 //BA.debugLineNum = 14;BA.debugLine="Dim MyMin As Double";
_mymin = 0;
 //BA.debugLineNum = 15;BA.debugLine="Dim MyHour As Double";
_myhour = 0;
 //BA.debugLineNum = 16;BA.debugLine="Dim MyDay As Double";
_myday = 0;
 //BA.debugLineNum = 18;BA.debugLine="Dim Noti1 As Notification";
_noti1 = new anywheresoftware.b4a.objects.NotificationWrapper();
 //BA.debugLineNum = 20;BA.debugLine="Dim MyNow2 As Long";
_mynow2 = 0L;
 //BA.debugLineNum = 21;BA.debugLine="Dim MyTimeDelta As Long";
_mytimedelta = 0L;
 //BA.debugLineNum = 23;BA.debugLine="End Sub";
return "";
}
public static String  _service_create() throws Exception{
 //BA.debugLineNum = 24;BA.debugLine="Sub Service_Create";
 //BA.debugLineNum = 26;BA.debugLine="TimerService.Initialize(\"TimerService\",1)";
_timerservice.Initialize(processBA,"TimerService",(long)(1));
 //BA.debugLineNum = 27;BA.debugLine="TimerService.Enabled=True";
_timerservice.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 29;BA.debugLine="Noti1.Initialize";
_noti1.Initialize();
 //BA.debugLineNum = 30;BA.debugLine="Noti1.Icon = \"icon\" 'use the application icon file for the notification";
_noti1.setIcon("icon");
 //BA.debugLineNum = 31;BA.debugLine="Noti1.Vibrate = False";
_noti1.setVibrate(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 32;BA.debugLine="Noti1.Sound = False";
_noti1.setSound(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 33;BA.debugLine="Noti1.Light=False";
_noti1.setLight(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 34;BA.debugLine="Noti1.SetInfo(\"Service Example\", \"Counter\", Main)";
_noti1.SetInfo(processBA,"Service Example","Counter",(Object)(mostCurrent._main.getObject()));
 //BA.debugLineNum = 36;BA.debugLine="Service.StartForeground(1, Noti1)";
mostCurrent._service.StartForeground((int)(1),(android.app.Notification)(_noti1.getObject()));
 //BA.debugLineNum = 37;BA.debugLine="MyMilliSec=0";
_mymillisec = 0;
 //BA.debugLineNum = 38;BA.debugLine="MySec=0";
_mysec = 0;
 //BA.debugLineNum = 39;BA.debugLine="MyMin=0";
_mymin = 0;
 //BA.debugLineNum = 40;BA.debugLine="MyHour=0";
_myhour = 0;
 //BA.debugLineNum = 41;BA.debugLine="MyDay=0";
_myday = 0;
 //BA.debugLineNum = 43;BA.debugLine="End Sub";
return "";
}
public static String  _service_destroy() throws Exception{
 //BA.debugLineNum = 51;BA.debugLine="Sub Service_Destroy";
 //BA.debugLineNum = 53;BA.debugLine="Service.StopForeground(1)";
mostCurrent._service.StopForeground((int)(1));
 //BA.debugLineNum = 54;BA.debugLine="ToastMessageShow(\"Service Stopped!\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Service Stopped!",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 55;BA.debugLine="MyMilliSec=0";
_mymillisec = 0;
 //BA.debugLineNum = 56;BA.debugLine="MySec=0";
_mysec = 0;
 //BA.debugLineNum = 57;BA.debugLine="MyMin=0";
_mymin = 0;
 //BA.debugLineNum = 58;BA.debugLine="MyHour=0";
_myhour = 0;
 //BA.debugLineNum = 59;BA.debugLine="MyDay=0";
_myday = 0;
 //BA.debugLineNum = 62;BA.debugLine="End Sub";
return "";
}
public static String  _service_start(anywheresoftware.b4a.objects.IntentWrapper _startingintent) throws Exception{
 //BA.debugLineNum = 45;BA.debugLine="Sub Service_Start (StartingIntent As Intent)";
 //BA.debugLineNum = 49;BA.debugLine="End Sub";
return "";
}
public static String  _timerservice_tick() throws Exception{
 //BA.debugLineNum = 64;BA.debugLine="Sub TimerService_Tick";
 //BA.debugLineNum = 66;BA.debugLine="MyNow2 = DateTime.now";
_mynow2 = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 67;BA.debugLine="Log(MyNow2)";
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_mynow2));
 //BA.debugLineNum = 68;BA.debugLine="MyTimeDelta = MyNow2-Main.MyNow1";
_mytimedelta = (long)(_mynow2-mostCurrent._main._mynow1);
 //BA.debugLineNum = 69;BA.debugLine="Log(MyTimeDelta)";
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_mytimedelta));
 //BA.debugLineNum = 71;BA.debugLine="MyDay=Floor(MyTimeDelta/86400000)";
_myday = anywheresoftware.b4a.keywords.Common.Floor(_mytimedelta/(double)86400000);
 //BA.debugLineNum = 72;BA.debugLine="MyTimeDelta=MyTimeDelta-MyDay*86400000";
_mytimedelta = (long)(_mytimedelta-_myday*86400000);
 //BA.debugLineNum = 73;BA.debugLine="MyHour=Floor(MyTimeDelta/3600000)";
_myhour = anywheresoftware.b4a.keywords.Common.Floor(_mytimedelta/(double)3600000);
 //BA.debugLineNum = 74;BA.debugLine="MyTimeDelta=MyTimeDelta-MyHour*3600000";
_mytimedelta = (long)(_mytimedelta-_myhour*3600000);
 //BA.debugLineNum = 75;BA.debugLine="MyMin=Floor(MyTimeDelta/60000)";
_mymin = anywheresoftware.b4a.keywords.Common.Floor(_mytimedelta/(double)60000);
 //BA.debugLineNum = 76;BA.debugLine="MyTimeDelta=MyTimeDelta-MyMin*60000";
_mytimedelta = (long)(_mytimedelta-_mymin*60000);
 //BA.debugLineNum = 77;BA.debugLine="MySec=Floor(MyTimeDelta/1000)";
_mysec = anywheresoftware.b4a.keywords.Common.Floor(_mytimedelta/(double)1000);
 //BA.debugLineNum = 78;BA.debugLine="MyTimeDelta=MyTimeDelta-MySec*1000";
_mytimedelta = (long)(_mytimedelta-_mysec*1000);
 //BA.debugLineNum = 79;BA.debugLine="MyMilliSec=MyTimeDelta";
_mymillisec = _mytimedelta;
 //BA.debugLineNum = 81;BA.debugLine="End Sub";
return "";
}
}
