﻿Type=Service
Version=2.71
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#StartCommandReturnValue: android.app.Service.START_STICKY
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim TimerService As Timer
	
	Dim MyMilliSec As Double
  	Dim MySec As Double 
	Dim MyMin As Double
	Dim MyHour As Double
	Dim MyDay As Double
	
	Dim Noti1 As Notification
	
	Dim MyNow2 As Long
	Dim MyTimeDelta As Long

End Sub
Sub Service_Create

	TimerService.Initialize("TimerService",1)
  	TimerService.Enabled=True
	
	Noti1.Initialize
    Noti1.Icon = "icon" 'use the application icon file for the notification
    Noti1.Vibrate = False
    Noti1.Sound = False	
	Noti1.Light=False
	Noti1.SetInfo("Service Example", "Counter", Main)

    Service.StartForeground(1, Noti1)
	MyMilliSec=0
	MySec=0
	MyMin=0
	MyHour=0
	MyDay=0

End Sub

Sub Service_Start (StartingIntent As Intent)
	
	
	
End Sub

Sub Service_Destroy

	Service.StopForeground(1)
	ToastMessageShow("Service Stopped!", False)
	MyMilliSec=0
	MySec=0
	MyMin=0
	MyHour=0
	MyDay=0
	

End Sub

Sub TimerService_Tick
  
  MyNow2 = DateTime.now
  Log(MyNow2)
  MyTimeDelta = MyNow2-Main.MyNow1
  Log(MyTimeDelta)
  
  MyDay=Floor(MyTimeDelta/86400000)
  MyTimeDelta=MyTimeDelta-MyDay*86400000
  MyHour=Floor(MyTimeDelta/3600000)
  MyTimeDelta=MyTimeDelta-MyHour*3600000
  MyMin=Floor(MyTimeDelta/60000)
  MyTimeDelta=MyTimeDelta-MyMin*60000
  MySec=Floor(MyTimeDelta/1000)
  MyTimeDelta=MyTimeDelta-MySec*1000
  MyMilliSec=MyTimeDelta

End Sub
